- name: Postgresql Password 
  include_tasks: "postgresql_password.yml" 

- name: Postgresql Pod 
  include_tasks: "postgresql_pod.yml" 

- name: Check if postgres is ready
  shell:
    kubectl exec -n {{ database_namespace }} {{ postgresql_pod_name }} -- bash -c 'pg_isready -U postgres'
  register: isready
  until: isready.rc == 0
  retries: 20
  delay: 5

- name: Get Minio Secret
  k8s_secret_info:
    namespace: "{{ config.backup_vault.namespace }}"
    name: minio-secret
  register: minio_secret

- name: List content Backup S3
  aws_s3:
    aws_access_key: "{{ minio_secret['accesskey'] }}"
    aws_secret_key: "{{ minio_secret['secretkey'] }}"
    bucket: "{{ database_namespace }}"
    mode: list
    prefix: "{{ database }}"
    s3_url: "https://{{ config.backup_vault.fqdn }}"
  register: backups

- name: Download latest Backup
  aws_s3:
    aws_access_key: "{{ minio_secret['accesskey'] }}"
    aws_secret_key: "{{ minio_secret['secretkey'] }}"
    bucket: "{{ database_namespace }}"
    object: "{{ backup }}"
    mode: get
    dest: "{{ install_dir }}/{{ database }}/{{ database }}.dump"
    s3_url: "https://{{ config.backup_vault.fqdn }}"
  vars:
    backup: "{{ backups.s3_keys | sort | last }}"

- name: Check Restore file exists
  stat:
    path: "{{ install_dir }}/{{ database }}/{{ database }}.dump"
  register: dump
  failed_when: dump.stat.exists == false

- name: Copy Backup to /tmp on the Postgresql Pod
  shell: |
    kubectl cp -n {{ database_namespace }} {{ install_dir }}/{{ database }}/{{ database }}.dump {{ postgresql_pod_name }}:/tmp

- name: Restore Backup using psql in the pod
  shell: |
    kubectl exec -n {{ database_namespace }} {{ postgresql_pod_name }} -- \
      bash -c 'PGPASSWORD={{ postgresql_password }} pg_restore -Fc -c -U postgres -d {{ database }}  /tmp/{{ database }}.dump'
  no_log: "{{ config.system.hide_secrets_from_log }}"
